module essentials 

implicit none

!	Checking single & double precision
integer, parameter :: single = SELECTED_REAL_KIND(p=6, r=37)
integer, parameter :: double = SELECTED_REAL_KIND(p=13)

!	Declaring essential variables for thermo_props that's not temperature dependent

integer :: ncp											! number of chemical components
integer :: max											! number of association sites
integer :: status11										! Hydrogen bonding switch	
integer :: PC_Dispersion								! CK or PC SAFT dispersion
integer :: analytic_flag								! use the 2 site analytic model for alcohols
integer :: polar_flag									! turns on or off the multipolar code
integer :: npts											! number of data points to be taken
integer :: system										! System to be modeled used in input_parameters
integer :: polymer									
logical purefluid
integer ipure
real (KIND=double) :: Pset								! guess pressure in Bar
real (KIND=double), dimension(4,9) :: D
real (KIND=double), dimension(50) :: m_tmp
real (KIND=double), dimension(50) :: mw_tmp
real (KIND=double), dimension(50,50) :: u0_tmp
real (KIND=double), dimension(50) :: e_ii_tmp
real (KIND=double), dimension(50,50,8,8) :: kappa_tmp
real (KIND=double), dimension(50,50) :: sig_tmp
real (KIND=double), dimension(50) :: v00_tmp
real (KIND=double), dimension(50,50) :: kij_tmp
real (KIND=double), dimension(50) :: z
real (KIND=double), dimension(50) :: z_chpt
real (KIND=double), dimension(50) :: h
real (KIND=double), dimension(50) :: q_tmp
real (KIND=double), dimension(50) :: mu_tmp
real (KIND=double), dimension(10) :: epsilon_tmp
real (KIND=double), dimension(10) :: kap_tmp

integer, dimension(20) :: N_sites_tmp

! Declaring essential variables for TX flash
!
real (KIND=double), dimension(200,50) :: xcomp
real (KIND=double), dimension(200) :: TCA
real (KIND=double), dimension(200) :: xliq
real (KIND=double), dimension(200) :: xvap
real (KIND=double)				   :: PL, PV, initial_guess


!	Declaring essential variables that are T dependent
real (KIND=double) :: TK
real (KIND=double) :: rhox_tmp
real (KIND=double), dimension(50) :: x_tmp
real (KIND=double), dimension(50) :: xq_tmp
real (KIND=double), dimension(50) :: xd_tmp
real (KIND=double), dimension(50,50,8,8,2) :: fa_tmp
real (KIND=double), dimension(50,50,8,8,1) :: fb_tmp
real (KIND=double), dimension(50) :: partition


!	Data fitting essential variables
real (KIND=double) :: TK_exp(50)
real (KIND=double) :: Pset_exp(50)
integer :: ndp_exp
real (KIND=double) :: x_exp(2,50)
real (KIND=double) :: y_exp(2,50)


save
end module
