
subroutine partition_calc(input, output, N)		! used with dneqnf

!	For two phase calculations only. 
!	This subroutine calculate the alpha (liquid vapor ratio)


use essentials
implicit none

!	Input/Output argument list
real (KIND=double), intent(in) :: input				! alpha (Vapor/Feed ratio)
real (KIND=double), intent(out) :: output			! a value that should be 0
integer, intent(in) :: N

!	Locally used working variables
real (KIND=double) :: input2
real (KIND=double) :: sum
integer :: i


input2 = input

if (input .eq. 1.0d0) then
  input2 = 0.9999999999999
end if


if  (input .lt. 0.0d0)  then
  output = 1000.0

else if (input .gt. 1.0) then
  output = 1000.0
else
	output = partition(1)*z(1)+partition(2)*z(2)-input2*partition(1)+input2*partition(1) &
			& *partition(2) - 1.0d0 + input2 - input2*partition(2)
	
	output = output*output

end if


end subroutine

